//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "SvrThrd.h"
#include "SvrMain.h"
//---------------------------------------------------------------------------

#pragma package(smart_init)
//---------------------------------------------------------------------------

// TServerThread

__fastcall TServerThread::TServerThread( TMCustomTCP * aSocket )
    : TThread( false ), FSocket( aSocket )
{
    FreeOnTerminate = true;
}
//---------------------------------------------------------------------------

void __fastcall TServerThread::AddLog( AnsiString aStr )
{
    FErrStr = aStr;
    Synchronize( WriteLog );
}
//---------------------------------------------------------------------------

void __fastcall TServerThread::WriteLog( void )
{
    Form1->Memo1->Lines->Add( FErrStr );
}
//---------------------------------------------------------------------------

void __fastcall TServerThread::Execute( )
{
    TMemoryStream * aData = new TMemoryStream( );
    try
    {
        while ( ( !Terminated ) && ( !FSocket->WaitForRecv( ) ) ) ;
        if ( !Terminated )
        {
            AnsiString s = FSocket->RecvText( "\0xd\0xa" );
            AddLog( s );
            aData->LoadFromFile( s );
            AddLog( IntToStr( aData->Size ) );
            FSocket->SendData( aData );
            AddLog( "Sent ok" );
        }
        while ( ( !Terminated ) && ( !FSocket->WaitForRecv( ) ) ) ;
    }
    catch ( ... )
    {
    }
    delete aData;
    delete FSocket;
}
//---------------------------------------------------------------------------

// TServerThread

//---------------------------------------------------------------------------

void __fastcall TSvrSocketThread::AddLog( AnsiString aStr )
{
    FErrStr = aStr;
    Synchronize( WriteLog );
}
//---------------------------------------------------------------------------

void __fastcall TSvrSocketThread::WriteLog( void )
{
    Form1->Memo1->Lines->Add( FErrStr );
}
//---------------------------------------------------------------------------

void __fastcall TSvrSocketThread::ClientExecute( )
{
    TMBWinSocketStream * strm = new TMBWinSocketStream( ClientSocket, 100000 );
    try {
        AnsiString s = strm->RecvText( "\0xd\0xa" );
        AddLog( s );
        TFileStream * fs = new TFileStream( s, fmOpenRead );
        try {
            AddLog( IntToStr( fs->Size ) );
            strm->SendStream( fs );
            AddLog( "Sent ok" );
        }
        __finally {
            delete fs;
            delete strm;
            ClientSocket->Close( );
        }
    }
    catch ( Exception &e ) {
        AddLog( AnsiString( "Error:" ) + e.Message );
    }
}
//---------------------------------------------------------------------------

