unit svrMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MSocket, StdCtrls, ScktComp;

type
  TForm1 = class(TForm)
    MUDP1: TMUDP;
    chkUDPServer: TCheckBox;
    chkTCPServer: TCheckBox;
    chkServerSocket: TCheckBox;
    ServerSocket1: TServerSocket;
    Memo1: TMemo;
    procedure MUDP1Request(Sender: TObject; aRequest: String);
    procedure chkUDPServerClick(Sender: TObject);
    procedure chkTCPServerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chkServerSocketClick(Sender: TObject);
    procedure ServerSocket1GetThread(Sender: TObject;
      ClientSocket: TServerClientWinSocket;
      var SocketThread: TServerClientThread);
  private
    FServerSocket : TMTCPServer;

    Procedure ServerConnect( Sender : TObject; aSocket : TMCustomTCP );
  public
    //
  end;

var
  Form1: TForm1;

implementation

uses svrThrd;

{$R *.DFM}

procedure TForm1.MUDP1Request(Sender: TObject; aRequest: String);
begin
    If ( aRequest = 'Request' ) Then
        MUDP1.ServerSocket.SendString( 'Ok!' )
    Else
        MUDP1.ServerSocket.SendString( 'Error!' );
end;

procedure TForm1.chkUDPServerClick(Sender: TObject);
begin
	MUDP1.Active := chkUDPServer.Checked;
end;

procedure TForm1.chkTCPServerClick(Sender: TObject);
begin
    If ( chkServerSocket.Checked AND ServerSocket1.Active ) Then
        chkServerSocket.Checked := false;
	FServerSocket.Active := chkTCPServer.Checked;
end;

procedure TForm1.chkServerSocketClick(Sender: TObject);
begin
    If ( chkTCPServer.Checked AND FServerSocket.Active ) Then
        chkTCPServer.Checked := false;
    ServerSocket1.Active := chkServerSocket.Checked;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
    FServerSocket := TMTCPServer.Create;
    FServerSocket.LocalPort := 10002;
    FServerSocket.OnConnect := ServerConnect;
    If ( FileExists( 'c:\sock.log' ) ) Then
        Memo1.Lines.LoadFromFile( 'c:\sock.log' );
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    Memo1.Lines.SaveToFile( 'c:\sock.log' );
    FServerSocket.Free;
end;

Procedure TForm1.ServerConnect( Sender : TObject; aSocket : TMCustomTCP );
Begin
    TTCPServerThread.Create( aSocket );
End;

procedure TForm1.ServerSocket1GetThread(Sender: TObject;
  ClientSocket: TServerClientWinSocket;
  var SocketThread: TServerClientThread);
begin
    SocketThread := TSvrSocketThread.Create( false, ClientSocket );
end;

end.

