(*
    MScktCmp : һ WinSock ʽͨŵĵԪ
    Copyright (c) Mar.20, Apr.03, 08, 24, May.23, Jul.07-02
        by Mental Studio -- http://msrc.126.com
    Author   : <raptorz@163.com>
    Version  : 1.6
    Comment  : Ԫһ࣬һԶ쳣
    TMBWinSocketStream - չTWinSocketStream
        ҪṩĶԷֱڷ/ ݿ//ı/ַ
    EMBSocket          - Զ쳣ĬϹ캯 Socket 

    ʹзκ Bug ϵһᾡлл
    Ϣμ뱾ļһ𷢲 Readme.txt  License.txt ļ
*)
unit MBSocket;

interface

Uses
    Classes, SysUtils, WinSock, ScktComp;

Type
    TMBSocketProgress = Procedure ( Sender : TObject; aProgress : Integer ) Of Object;

    TMBWinSocketStream = class( TWinSocketStream )
    private
    	FSocket : TCustomWinSocket;

        FOnProgress : TMBSocketProgress;

    Public
    	Constructor Create( aSocket : TCustomWinSocket; aTimeout : Integer );

        Procedure RecvBuffer( Var aBuffer; aSize : Integer );
        Procedure SendBuffer( Var aBuffer; aSize : Integer );
        Procedure RecvStream( aStream : TStream; aSize : Integer = -1 );
        Procedure SendStream( aStream : TStream; aSize : Integer = -1 );
        Function  RecvText( aDelimit : String = #13#10 ) : String;
        Procedure SendText( aStr : String );
        Function  RecvString : String;
        Procedure SendString( aStr : String );

        Property OnProgress : TMBSocketProgress read FOnProgress write FOnProgress;
    End;

    EMBSocket = class( Exception )
    Public
        Constructor Create; overload;
    End;

    Function IsIPAddress( s : String ) : Boolean;

implementation

ResourceString
    crsActiveCannot = 'Socket is active, cannot do this operate!';
    crsMustActive   = 'Socket is not active, cannot do this operate!';
    crsTimeout      = 'Operate timed out!';
    crsReadError    = 'Reading socket error!';

Function IsIPAddress( s : String ) : Boolean;
Begin
	s := Trim( s );
	Result := ( s[1] >= '0' ) AND ( s[1] <= '9' );
End;

{ TMBWinSocketStream }

constructor TMBWinSocketStream.Create(aSocket: TCustomWinSocket;
  aTimeout: Integer);
begin
	Inherited;
    FSocket := aSocket;  //  Ϊ TWinSocketStream  FSocket ˽еģҪһݸ
end;

//  ȴݿ
procedure TMBWinSocketStream.RecvBuffer(var aBuffer; aSize: Integer);
Var
    p : PChar;
begin
    If ( WaitForData( Timeout ) ) Then
	Begin
        p := @aBuffer;
        While ( aSize > 0 ) Do
        Begin
            If ( Not WaitForData( Timeout ) ) Then
                Raise EMBSocket.Create( crsTimeout );
            Inc( p, Read( p^, aSize ) );
            aSize := aSize - ( p - @aBuffer );
        End;
    End
    Else
        Raise EMBSocket.Create( crsTimeout );
end;

//  ָȵ
//  δָݳȣĬϵaSize=-1ʹԤЭ
//  ԤЭΪһ32λֵ¼ȣΪ
procedure TMBWinSocketStream.RecvStream(aStream: TStream; aSize: Integer);
Var
    n, nPos, nSize : Integer;
    p : Pointer;
begin
    If ( WaitForData( Timeout ) ) Then
    Begin
        GetMem( p, 8192 );
        Try
            If ( aSize > 0 ) Then                  //  
                nSize := aSize
            Else
                RecvBuffer( nSize, SizeOf( nSize ) );
            nPos := 0;
            Repeat                                 //  ֿ
                n := nSize - nPos;
                If ( n > 8192 ) Then
                    n := 8192;
                n := Read( p^, n );                //   ReadBuffer ڽݲͨΪ״ãʱ쳣ǵȴ
                aStream.WriteBuffer( p^, n );
                Inc( nPos, n );
                If ( Assigned( FOnProgress ) ) Then
                    FOnProgress( Self, Round( nPos / nSize * 100 ) );
            Until ( nPos = nSize );
        Finally
            FreeMem( p );
        End;
    End
    Else
        Raise EMBSocket.Create( crsTimeout );
end;

function TMBWinSocketStream.RecvString: String;
Var
    mem : TMemoryStream;
begin
    mem := TMemoryStream.Create;
    Try
        RecvStream( mem );
        Result := String( PChar( mem.Memory ) );
    Finally
        mem.Free;
    End;
end;

//  һ aDelimit ַβַ
function TMBWinSocketStream.RecvText(aDelimit: String): String;
Var
    nSize : Integer;
    p, t  : PChar;
begin
    Result := '';
    If ( WaitForData( Timeout ) ) Then
    Begin                                          //  ȡûеݳ
        If ( ( ioctlsocket( FSocket.SocketHandle, FIONREAD, nSize ) = SOCKET_ERROR )
            OR ( nSize <= 0 ) ) Then
            Raise EMBSocket.Create;
        GetMem( p, nSize + 1 );
        Try                                        //  Peek е
            nSize := recv( FSocket.SocketHandle, p^, nSize, MSG_PEEK );
            If ( nSize = SOCKET_ERROR ) Then
                Raise EMBSocket.Create;
            PByteArray( p )^[nSize] := 0;
            t := StrPos( p, PChar( aDelimit ) );
            If ( t <> Nil ) Then
                nSize := t - p + Length( aDelimit );// aDelimit ĳ
            RecvBuffer( p^, nSize );               //  
            PByteArray( p )^[nSize - Length( aDelimit )] := 0;
            Result := String( p );
        Finally
            FreeMem( p );
        End;
    End
    Else
        Raise EMBSocket.Create( crsTimeout );
end;

//  һݿ
procedure TMBWinSocketStream.SendBuffer(var aBuffer; aSize: Integer);
begin
    WriteBuffer( aBuffer, aSize );
end;

//  һָȵݣ
//  δָȣʹĬϳ-1ʱĬЭ飬
//  Эĺ˵
procedure TMBWinSocketStream.SendStream(aStream: TStream; aSize: Integer);
Var
    nSize : Integer;
    p : Pointer;
begin
    GetMem( p, 8192 );
    Try
        If ( aSize > 0 ) Then
            nSize := aSize
        Else
        Begin
            nSize := aStream.Size - aStream.Position;
            WriteBuffer( nSize, SizeOf( nSize ) );
        End;
        Repeat
            If ( nSize > 8192 ) Then
                nSize := 8192;
            nSize := aStream.Read( p^, nSize );
            WriteBuffer( p^, nSize );
            If ( Assigned( FOnProgress ) ) Then
                FOnProgress( Self, Round( aStream.Position / aStream.Size * 100 ) );
            nSize := aStream.Size - aStream.Position;
        Until ( nSize = 0 );
    Finally
        FreeMem( p );
    End;
end;

procedure TMBWinSocketStream.SendString(aStr: String);
Var
    mem : TMemoryStream;
    p   : PChar;
begin
    If ( aStr <> '' ) Then
    Begin
        mem := TMemoryStream.Create;
        Try
            mem.Size := Length( aStr ) + 1;
            p := PChar( mem.Memory );
            FillChar( p^, mem.Size, 0 );
            StrCopy( p, PChar( aStr ) );
            SendStream( mem );
        Finally
            mem.Free;
        End;
    End;

end;

//  һַ
procedure TMBWinSocketStream.SendText(aStr: String);
begin
    WriteBuffer( PChar( aStr )^, Length( aStr ) );
end;

{ EMBSocket }

constructor EMBSocket.Create;
begin
    Inherited Create( 'General socket error : ' + IntToStr( WSAGetLastError ) );
end;

end.
