(*
    MSocket : һ WinSock ͨŵĵԪ
    Copyright (c) Jul.1-01 1:20, Oct.29 21:20, Nov.4 0:20,
        Mar.10, Apr.10-02 19:20 by Mental Studio -- http://msrc.126.com
    Author  : <raptorz@163.com>
    Version : 1.5
    Comment : Ԫһһؼǿӣ
    TMCustomSocket - WinSock Ļʵ֣
    TMCustomTCP    - TCP Ļʵ
    TMTCPServer    - TCP ķʵ
    TMTCPClient    - TCP Ŀͻʵ
    TMUDPSocket    - UDP ʵ
    TMUDP          - һ UDP ͨŵĿؼ
    ṹ£
                TMCustomSocket
                      |
                +-----+-----+
                |           |
          TMCustomTCP  TMUDPSocket
                |
          +-----+-----+
          |           |
    TMTCPServer  TMTCPClient

    TMUDP ؼʹ TMUDPSocket 

    ʹзκ Bug ϵһᾡлл
    Ϣμ뱾ļһ𷢲 Readme.txt  License.txt ļ
*)
unit MSocket;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, WinSock;

Const
	SOCKET_SUCCESS = 0;
//    SOCKET_ERROR   = -1;  //  defined
    SOCKET_WARNING = -2;

    WM_MENTALUDP   = WM_USER + $3600;
    WM_MENTALTCP   = WM_USER + $3601;

    cnRetryTimes   = 3;

type

	TAPInAddr = Array [0..10] Of PInAddr;
    PAPInAddr = ^TAPInAddr;

(*
     WinSock ࣬ TCP/UDP еĲ֣һ࣬
     Open ԱΪ
*)
  TMCustomSocket = class(TObject)
  private
    FSocket  : TSocket;    //  WinSock Handle
    FLocal   : TSockAddr;  //  Local Address Info
    FRemote  : TSockAddr;  //  Remote Address Info(be filled after some operate)
    FLocHost : String;     //  Local Host Name  \_ be filled by
    FLocAddr : String;     //  Local IP Address /  GetLocalHostAddr procedure
    FTimeOut : Integer;    //  Socket time out, by miliseconds

    Procedure GetLocalHostAddr;
    Function  GetActive : Boolean;
    Procedure SetActive( aActive : Boolean );
    Function  GetLocalHost : String;
    Function  GetLocalAddr : String;
    Function  GetLocalPort : Integer;
    Procedure SetLocalPort( aPort : Integer );
    Function  GetRemoteHost : String;
    Function  GetRemoteAddr : String;
    Procedure SetRemoteHostAddr( aHostAddr : String );
    Function  GetRemotePort : Integer;
    Procedure SetRemotePort( aPort : Integer );

  protected
    Procedure SetTimeOut( aTimeOut : Integer ); Virtual;

    Procedure Open; Virtual; Abstract;
    Procedure Close; Virtual;

  public
    Constructor Create;
    Destructor  Destroy; Override;

    function  WaitForRecv : Boolean;

    Property Socket     : TSocket Read FSocket;
    Property Active     : Boolean Read GetActive     Write SetActive;
    Property LocalHost  : String  Read GetLocalHost;
    Property LocalAddr  : String  Read GetLocalAddr;
    Property LocalPort  : Integer Read GetLocalPort  Write SetLocalPort;
    Property RemoteHost : String  Read GetRemoteHost Write SetRemoteHostAddr;
    Property RemoteAddr : String  Read GetRemoteAddr Write SetRemoteHostAddr;
    Property RemotePort : Integer Read GetRemotePort Write SetRemotePort;
    Property TimeOut    : Integer Read FTimeOut      Write SetTimeOut;
  end;

  //   TCP ¼
  TMTCPProgressEvent = Procedure ( Sender : TObject; aPercent : Integer ) of object;

  (*
    TCP Ļ࣬ʵ TCP Server/Client Ĺ
  *)
  TMCustomTCP = class( TMCustomSocket )
  Private
    FOnProgress : TMTCPProgressEvent;
  Public
    Constructor Create;
    Destructor  Destroy; Override;

    Procedure Open; Override;
    Procedure Close; Override;

  	Procedure SendData( aData : TStream );
    Procedure RecvData( aData : TStream );
    Procedure SendBuf( Const aData : PByte; Const aSize : Integer );
    Procedure RecvBuf( Const aData : PByte; Const aSize : Integer );
    Procedure SendString( Const aStr : String );
    Function  RecvString : String;
    Procedure SendText( Const aStr : String );
    Function  RecvText( aDelimit : String = #13#10 ) : String;

    Property OnProgress : TMTCPProgressEvent Read FOnProgress Write FOnProgress;
  End;

  //   TCP ¼
  TMTCPConnectEvent   = Procedure ( Sender : TObject; aSocket : TMCustomTCP ) Of Object;

  //  TCP ˣҪṩ OnConnect Ӧͻ˵ͨڴ¼½߳
  TMTCPServer = class( TMCustomTCP )
  Private
    FWindow    : HWND;

    FOnConnect : TMTCPConnectEvent;

    Procedure SocketMessage( Var Message : TMessage );

  Public
  	Constructor Create;
    Destructor  Destroy; Override;

    Procedure Open; Override;
    procedure Close; Override;

    Property OnConnect : TMTCPConnectEvent Read FOnConnect Write FOnConnect;
  End;

  //  TCP ͻˣҪӣṩ OnConnected ¼ڴӺĲ
  TMTCPClient = class( TMCustomTCP )
  Public
  	Constructor Create;
    Destructor  Destroy; Override;

    Procedure Open; Override;
  End;

  (*
    UDP ͨ࣬ʵִԱ Open շϢԱ
    SendMessage/RecvMessage
  *)
  TMUDPSocket = class( TMCustomSocket )
  Public
  	Constructor Create;
    Destructor  Destroy; Override;

    Procedure Open; Override;
    Procedure Close; Override;
    Procedure SendString( aMessage : String );
    Function  RecvString : String;
//  ֱ SendMessage/RecvMessage ҵ BCB5 һ BUG 
//  ѽ SendMessage ĺԶһ SendMessageA
//  Ϊ Windows API  SendMessage Եʣ
//  ж SendMessage ĵöᱻɶ SendMessageA ĵã
//   DELPHI ûʵأ BCB5 ķʱ
//  û취ֻøΪ SendString/RecvString  TMUDP ؼԭͬ
  End;

  //   UDP ¼
  TMUDPRequestEvent = Procedure ( Sender : TObject; aRequest : String ) of object;

  (*
    UDP ؼ RAD  UDP ͨų
  *)
  TMUDP = class(TComponent)
  private
    { Private declarations }
    FServer : TMUDPSocket;
    FClient : TMUDPSocket;
    FActive : Boolean;
    FWindow : HWND;
    FRetStr : String;
    FRemoteHost : String;
    FRemotePort : Integer;
    FLocalPort  : Integer;
    FTimeOut    : Integer;

    FOnRequest  : TMUDPRequestEvent;

    Procedure StartServer;
    Procedure StopServer;
    Procedure SocketMessage( Var Message : TMessage );
    Function  GetActive : Boolean;
    Procedure SetActive( aActive : Boolean );
    Procedure SetRemoteHost( aRemoteHost : String  );
    Procedure SetRemotePort( aRemotePort : Integer );
    Procedure SetLocalPort(  aLocalPort  : Integer );
  protected
    { Protected declarations }
    Procedure Loaded; Override;
  public
    { Public declarations }
    Constructor Create( AOwner : TComponent ); Override;
    Destructor  Destroy; Override;

    Procedure SendString(  aMessage : String );
    Function  SendRequest( aMessage : String ) : String;

    Property ServerSocket : TMUDPSocket read FServer;
    Property ClientSocket : TMUDPSocket read FClient;
  published
    { Published declarations }
    Property Active     : Boolean Read GetActive   Write SetActive;
    Property RemoteHost : String  Read FRemoteHost Write SetRemoteHost;
    Property RemotePort : Integer Read FRemotePort Write SetRemotePort;
    Property LocalPort  : Integer Read FLocalPort  Write SetLocalPort;
    Property TimeOut    : Integer Read FTimeOut    Write FTimeOut;

    Property OnRequest  : TMUDPRequestEvent Read FOnRequest Write FOnRequest;
  End;

  //  Զ쳣
  EMSocket = class( Exception )
  public
    Constructor Create; Overload;
  end;


Function  IsIPAddr( aName : String ) : Boolean;

procedure Register;

implementation

ResourceString
    crsErrActive      = 'This socket is opened!';
    crsErrNotActive   = 'This socket is closed!';
    crsErrInvSize     = 'Invalid data size!';
    crsErrSendData    = 'Send data error!';
//    crsErrRecvTimeout = 'Receive timed out!';
    crsErrRecvData    = 'Receive data error!';
    crsErrSocketCode  = 'Socket error code : ';
    crsErrSocketGeneral='General socket error!';

Const
    cnBlockSize = 8192;  //  TCP data package size
    cnMsgSize   = 256;   //  UDP data package size

//  

//  жһַ IP ַ
//  أtrue  - is an IP Address
//        false - is a Host Name
Function IsIPAddr( aName : String ) : Boolean;
Begin
	aName := Trim( aName );  //  ݵһǿոĸǷֶ
    Result := ( aName <> '' ) AND ( aName[1] >= '0' ) AND ( aName[1] <= '9' );
End;

//  жǷ Socket 
//  aError 
//  SOCKET_ERROR   - WinSock 󣬴 WSAGetLastError ȡ
//  SOCKET_WARNING - ԶҪ󣨾棩
//  ȷ
//  ֵޣȷ Except
Procedure SocketError( aError : Integer );
Begin
	If ( aError = SOCKET_ERROR ) Then
        Raise EMSocket.Create
    Else If ( aError = SOCKET_WARNING ) Then
        Raise EMSocket.Create( crsErrSocketGeneral );
End;

//  TMCustomSocket ʵ

//  캯ʼԱ
Constructor TMCustomSocket.Create;
Begin
	Inherited Create;
    FSocket                 := INVALID_SOCKET;
    FLocal.sin_family       := AF_INET;
    FLocal.sin_addr.S_addr  := htonl( INADDR_ANY );
    FLocal.sin_port         := htons( 0 );
    FRemote.sin_family      := AF_INET;
    FRemote.sin_addr.S_addr := htonl( INADDR_ANY );
    FRemote.sin_port        := htons( 0 );
    FLocHost                := '';
    FLocAddr                := '';
    FTimeOut                := 1000;
End;

//  ǰر Socket
Destructor TMCustomSocket.Destroy;
Begin
	Close;
    Inherited Destroy;
End;

//   Socket 򿪵Ļر
Procedure TMCustomSocket.Close;
Begin
	If ( FSocket <> INVALID_SOCKET ) Then
    Begin
    	closesocket( FSocket );
        FSocket := INVALID_SOCKET;
    End;
End;

//  ȴ
function TMCustomSocket.WaitForRecv : Boolean;
var
    FDSet   : TFDSet;
    TimeVal : TTimeVal;
begin
    TimeVal.tv_sec  := FTimeout div 1000;
    TimeVal.tv_usec := (FTimeout mod 1000) * 1000;
    FD_ZERO(FDSet);
    FD_SET(FSocket, FDSet);
    Result := select(0, @FDSet, nil, nil, @TimeVal) > 0;
end;

//  ȡñ IP Address & Host Name ֻڴΪʱִһ
Procedure TMCustomSocket.GetLocalHostAddr;
Var
	buf  : Array [0..63] Of Char;
    phe  : PHostEnt;
    ppia : PAPInAddr;
Begin
	If ( ( FLocHost = '' ) OR ( FLocAddr = '' ) ) Then
    Begin
    	gethostname( buf, sizeof( buf ) );
        FLocHost := buf;
        phe := gethostbyname( buf );
        If ( phe = Nil ) Then
        	Exit;
        ppia := PAPInAddr( phe^.h_addr_list );
       	FLocAddr := inet_ntoa( ppia^[0]^ );
    End;
End;

//  ж Socket Ƿ
Function TMCustomSocket.GetActive : Boolean;
Begin
	Result := ( FSocket <> INVALID_SOCKET );
End;

//  /ر Socket
Procedure TMCustomSocket.SetActive( aActive : Boolean );
Begin
    If ( aActive <> Active ) Then
    Begin
    	If ( aActive ) Then
            Open
        Else
        	Close;
    End;
End;

//  ȡñ Host Name
Function TMCustomSocket.GetLocalHost : String;
Begin
	If ( FLocHost = '' ) Then
    	GetLocalHostAddr;
    Result := FLocHost;
End;

//  ȡñ IP Address
Function TMCustomSocket.GetLocalAddr : String;
Begin
	If ( FLocAddr = '' ) Then
    	GetLocalHostAddr;
    Result := FLocAddr;
End;

//  ȡñ˿
Function TMCustomSocket.GetLocalPort : Integer;
Begin
	Result := ntohs( FLocal.sin_port );
End;

//  ñ˿
Procedure TMCustomSocket.SetLocalPort( aPort : Integer );
Begin
    If ( FLocal.sin_port <> htons( aPort ) ) Then
    Begin
        If ( Active ) Then
            Raise EMSocket.Create( crsErrActive );
        FLocal.sin_port := htons( aPort );
    End;
End;

//  ȡԶ
Function TMCustomSocket.GetRemoteHost : String;
Var
	phe : PHostEnt;
Begin
	Result := '';
	phe := gethostbyaddr( @( FRemote.sin_addr.S_addr ), 4, AF_INET );
    If ( phe <> Nil ) Then
    	Result := phe^.h_name;
End;

//  ȡԶַ
Function TMCustomSocket.GetRemoteAddr : String;
Begin
	Result := inet_ntoa( FRemote.sin_addr );
End;

//  Զ/ַݲǷΪ IP ַԶ
Procedure TMCustomSocket.SetRemoteHostAddr( aHostAddr : String );
Var
	phe : PHostEnt;
Begin
    If ( Active ) Then
        Raise EMSocket.Create( crsErrActive );
	aHostAddr := Trim( aHostAddr );
    If ( IsIPAddr( aHostAddr ) ) Then
    	FRemote.sin_addr.S_addr := inet_addr( PChar( aHostAddr ) )
    Else
    Begin
    	phe := gethostbyname( PChar( aHostAddr ) );
        If ( phe <> Nil ) Then
        	FRemote.sin_addr := PAPInAddr( phe^.h_addr_list )^[0]^;
    End;
End;

//  ȡԶ̶˿ں
Function TMCustomSocket.GetRemotePort : Integer;
Begin
	Result := ntohs( FRemote.sin_port );
End;

//  Զ̶˿ں
Procedure TMCustomSocket.SetRemotePort( aPort : Integer );
Begin
    If ( FRemote.sin_port <> htons( aPort ) ) Then
    Begin
        If ( Active ) Then
            Raise EMSocket.Create( crsErrActive );
        FRemote.sin_port := htons( aPort );
    End;
End;

//  óʱʱ
Procedure TMCustomSocket.SetTimeOut( aTimeOut : Integer );
Begin
	If ( aTimeOut <> FTimeOut ) Then
    Begin
        If ( Active ) Then
            Raise EMSocket.Create( crsErrActive );
		FTimeOut := aTimeOut;
    End;
End;

//  TMCustomTCP

//  ʼ TCP Ա
Constructor TMCustomTCP.Create;
Begin
	Inherited Create;
    FOnProgress := Nil;
End;

Destructor TMCustomTCP.Destroy;
Begin
	Inherited Destroy;
End;

//  һ TCP Socket 󶨱ַ/˿
Procedure TMCustomTCP.Open;
Begin
	If ( FSocket = INVALID_SOCKET ) Then
    Begin
    	FSocket := WinSock.socket( PF_INET, SOCK_STREAM, 0 );
        If ( FSocket = INVALID_SOCKET ) Then
        	SocketError( SOCKET_ERROR );
        SocketError( bind( FSocket, FLocal, SizeOf( FLocal ) ) );
        //  SO_RCVTIMO = $1006
        SocketError( setsockopt( FSocket, SOL_SOCKET, $1006, @FTimeOut, SizeOf( FTimeOut ) ) );
    End;
End;

//  ر TCP Socket
Procedure TMCustomTCP.Close;
Begin
	Inherited Close;
End;

//   TCP 
//  aData ΪҪ͵
Procedure TMCustomTCP.SendData( aData : TStream );
Var
	nError, nSize : Integer;
    p : PByte;
Begin
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
    nSize  := aData.Size;
    nError := send( FSocket, nSize, SizeOf( nSize ), 0 );      //  ȷܳ
    If ( nError <> SizeOf( nSize ) ) Then
        Raise EMSocket.Create;
    GetMem( p, cnBlockSize );                                  //  ݰ
    Try
        aData.Seek( 0, soFromBeginning );                      //  Ŀʼ
        While ( aData.Position < aData.Size ) Do               //  ѭ
        Begin
            nSize  := cnBlockSize;
            If ( nSize > aData.Size - aData.Position ) Then
                nSize := aData.Size - aData.Position;          //  ݰС
            aData.ReadBuffer( p^, nSize );                     //  жݰ
            nError := send( FSocket, p^, nSize, 0 );           //  һݰ
            If ( nError > 0 ) Then                             //  ѷʹССڰС
            Begin
                aData.Seek( nError - nSize, soFromCurrent );   //  ƶ㣬ѷͲ֣һ
                If ( Assigned( FOnProgress ) ) Then            //  ʾ
                    FOnProgress( Self, Round( aData.Position * 100 / aData.Size ) );
            End
            Else
                Raise EMSocket.Create;                         //  ʧ
        End;
    Finally
        FreeMem( p );                                          //  ͷŻ
    End;
End;

//   TCP 
//  յ aData
Procedure TMCustomTCP.RecvData( aData : TStream );
Var
	nError, nSize : Integer;
    p : PByte;
Begin
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
	If ( Not WaitForRecv ) Then                            //  ȴݵ
    	Raise EMSocket.Create;                             //  ֻһTimeoutʱ䣬ʱ
	nError := recv( FSocket, nSize, SizeOf( nSize ), 0 );  //  ȡܴС
    If ( nError = SizeOf( nSize ) ) then
    Begin
        aData.Size := nSize;
        aData.Seek( 0, soFromBeginning );
    End
    Else
    	Raise EMSocket.Create;
    GetMem( p, cnBlockSize );                              //  ݰ
    Try
        Repeat
            If ( Not WaitForRecv ) Then                    //  ȴһݰ
                Raise EMSocket.Create;                     //  ÿֻһTimeoutʱ䣬ʱ
            nSize := recv( FSocket, p^, cnBlockSize, 0 );  //  ȡݰ
            If ( nSize > 0 ) Then
            Begin
                aData.WriteBuffer( p^, nSize );            //  浽
                If ( Assigned( FOnProgress ) ) Then        //  ʾ
                    FOnProgress( Self, Round( aData.Position * 100 / aData.Size ) );
            End
            Else If ( nSize < 0 ) Then
                Raise EMSocket.Create;                     //  ݳ
        Until ( aData.Position = aData.Size );             //  ֱȫȡ
    Finally
        FreeMem( p );
    End;
End;

procedure TMCustomTCP.SendBuf( Const aData: PByte; Const aSize: Integer);
Var
    nSent : Integer;
    n     : Integer;
    p     : PByte;
begin
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
    nSent := 0;
    p     := aData;
    While ( nSent < aSize ) Do
    Begin
        n := cnBlockSize;
        If ( n > aSize - nSent ) Then
            n := aSize - nSent;
        n := send( FSocket, p^, n, 0 );          //  һݰ
        If ( n > 0 ) Then                        //  ѷʹССڰС
        Begin
            Inc( nSent, n );
            Inc( p, n );
            If ( Assigned( FOnProgress ) ) Then  //  ʾ
                FOnProgress( Self, Round( nSent * 100 / aSize ) );
        End
        Else
            Raise EMSocket.Create;               //  ʧ
    End;
end;

procedure TMCustomTCP.RecvBuf( Const aData: PByte; Const aSize: Integer);
Var
    nRcvd : Integer;
    n     : Integer;
    p     : PByte;
begin
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
    nRcvd := 0;
    p     := aData;
	If ( Not WaitForRecv ) Then                  //  ȴݵ
    	Raise EMSocket.Create;                   //  ֻһTimeoutʱ䣬ʱ
    While ( nRcvd < aSize ) Do
    Begin
        If ( Not WaitForRecv ) Then              //  ȴһݰ
            Raise EMSocket.Create;               //  ÿֻһTimeoutʱ䣬ʱ
        n := cnBlockSize;
        If ( n > aSize - nRcvd ) Then
            n := aSize - nRcvd;
        n := recv( FSocket, p^, n, 0 );          //  ȡݰ
        If ( n > 0 ) Then
        Begin
            Inc( p, n );
            Inc( nRcvd, n );
            If ( Assigned( FOnProgress ) ) Then  //  ʾ
                FOnProgress( Self, Round( nRcvd * 100 / aSize ) );
        End
        Else
            Raise EMSocket.Create;               //  ݳ
    End;
end;

procedure TMCustomTCP.SendString( Const aStr: String);
Var
    data : TMemoryStream;
begin
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
    data := TMemoryStream.Create;
    Try
        data.Size := Length( aStr );
        ZeroMemory( data.Memory, data.Size );
        StrCopy( data.Memory, PChar( aStr ) );
        SendData( data );
    Finally
        data.Free;
    End;
end;

function TMCustomTCP.RecvString: String;
Var
    data : TMemoryStream;
begin
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
    data := TMemoryStream.Create;
    Try
        RecvData( data );
        data.Size := data.Size + 1;
        PByteArray( data.Memory )^[data.Size - 1] := 0;
        Result := PChar( data.Memory );
    Finally
        data.Free;
    End;
end;

procedure TMCustomTCP.SendText(const aStr: String);
Var
    nSent : Integer;
    nSize : Integer;
    p     : PByte;
begin
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
    nSent := 0;
    nSize := Length( aStr ) + 1;
    GetMem( p, nSize );
    Try
        FillChar( p^, nSize, 0 );
        StrCopy( PChar( p ), PChar( aStr ) );
        While ( nSent < nSize ) Do
            //  һݰ
            nSent := nSent + send( FSocket, p^, nSize - nSent, 0 );
    Finally
        FreeMem( p );
    End;
end;

function TMCustomTCP.RecvText( aDelimit : String ): String;
Var
    nSize : Integer;
    p : PChar;
    t : PChar;
begin
    Result := '';
    If ( Not Active ) Then
        Raise EMSocket.Create( crsErrNotActive );
    If ( ioctlsocket( FSocket, FIONREAD, nSize ) = SOCKET_ERROR ) Then
        Raise EMSocket.Create;
    GetMem( p, nSize + 1 );
    Try
        nSize := recv( FSocket, p^, nSize, MSG_PEEK );
        PByteArray( p )^[nSize] := 0;
        t := StrPos( p, PChar( aDelimit ) );
        If ( t <> Nil ) Then
            nSize := t - p + Length( aDelimit );
        recv( FSocket, p^, nSize, 0 );
        PByteArray( p )^[nSize] := 0;
        Result := String( PChar( p ) );
    Finally
        FreeMem( p );
    End;
end;

//  TMTCPServer

Constructor TMTCPServer.Create;
Begin
	Inherited Create;
    FWindow := Forms.AllocateHWnd( SocketMessage );  //  ϢӦ
End;

Destructor TMTCPServer.Destroy;
Begin
    Close;                            //  ȹرգעϢ
    Forms.DeallocateHWnd( FWindow );  //  עϢӦ
	Inherited Destroy;
End;

//  첽ʽȴͻ˵
//  пͻӵ WM_MENTALTCP Ϣ
Procedure TMTCPServer.Open;
Begin
    Inherited Open;
    SocketError( WSAAsyncSelect( FSocket, FWindow, WM_MENTALTCP, FD_ACCEPT ) );
    listen( FSocket, 5 );
End;

//  עϢ
procedure TMTCPServer.Close;
begin
    If ( FSocket <> INVALID_SOCKET ) Then
        SocketError( WSAAsyncSelect( FSocket, FWindow, 0, 0 ) );
    Inherited Close;
end;

//  첽ʽϢ
procedure TMTCPServer.SocketMessage(var Message: TMessage);
Var
    aSocket : TMCustomTCP;
    nSize   : Integer;
Begin
    If ( Message.Msg = WM_MENTALTCP ) Then
    Begin
        If ( WSAGetSelectEvent( Message.LParam ) = FD_ACCEPT ) Then
        Begin
            Try
//  ɹʱ FOnConnect ¼ aSocket Ϊͻӵ Socket
                If ( Assigned( FOnConnect ) ) Then
                Begin
                    aSocket := TMCustomTCP.Create;
                    nSize   := SizeOf( aSocket.FRemote );
                    aSocket.FSocket := accept( FSocket, @( aSocket.FRemote ), @nSize );
                    If ( aSocket.FSocket <> INVALID_SOCKET ) Then
                    Begin
                        nSize := 0;  //  Ϊʽ
                        SocketError( WSAAsyncSelect( aSocket.FSocket, FWindow, 0, 0 ) );
                        SocketError( ioctlsocket( aSocket.FSocket, FIONBIO, nSize ) );
                        FOnConnect( Self, aSocket );
                    End
                    Else
                    	aSocket.Free;
                End;
            Except
                //  do nothing
            End;
        End;
    End
	Else
    	Message.Result := DefWindowProc( FWindow, Message.Msg, Message.WParam, Message.LParam );
End;

//  TMTCPClient

Constructor TMTCPClient.Create;
Begin
	Inherited Create;
End;

Destructor TMTCPClient.Destroy;
Begin
	Inherited Destroy;
End;

//  ˷
//  ʧ쳣
Procedure TMTCPClient.Open;
Var
    n : Integer;
Begin
    Inherited Open;
    If ( FSocket <> INVALID_SOCKET ) Then
    	SocketError( WinSock.connect( FSocket, FRemote, SizeOf( FRemote ) ) );
    n := 0;  //  Ϊʽ
    SocketError( ioctlsocket( FSocket, FIONBIO, n ) );
End;

//  TMUDPSocket

Constructor TMUDPSocket.Create;
Begin
	Inherited Create;
End;

Destructor TMUDPSocket.Destroy;
Begin
	Inherited Destroy;
End;

//  һ UDP Socket 󶨱ַ/˿
Procedure TMUDPSocket.Open;
Begin
	If ( FSocket = INVALID_SOCKET ) Then
    Begin
        FSocket := WinSock.socket( PF_INET, SOCK_DGRAM, 0 );
        If ( FSocket = INVALID_SOCKET ) Then
        	SocketError( SOCKET_ERROR );
        SocketError( bind( FSocket, FLocal, SizeOf( FLocal ) ) );
    End;
End;

//  ر UDP Socket
procedure TMUDPSocket.Close;
begin
	Inherited Close;
end;

//  һ UDP Ϣ
//  aMessage ΪҪ͵Ϣ
Procedure TMUDPSocket.SendString( aMessage : String );
Var
	nSize, nError : Integer;
    buf, p : PByte;
Begin
	If ( FSocket <> INVALID_SOCKET ) Then
    Begin
    	nSize := Length( aMessage ) + 1;
        GetMem( buf, nSize );                            //  仺
        Try
            ZeroMemory( buf, nSize );
            StrCopy( PChar( buf ), PChar( aMessage ) );
            p := buf;
            nError := sendto( FSocket, nSize, SizeOf( nSize ), 0, FRemote, SizeOf( FRemote ) );
            If ( nError <> SizeOf( nSize ) ) Then
                Raise EMSocket.Create( crsErrInvSize );
            While ( nSize > 0 ) Do
            Begin
                nError := cnMsgSize;
                If ( nSize < cnMsgSize ) Then
                    nError := nSize;
                nError := sendto( FSocket, p^, nError, 0, FRemote, SizeOf( FRemote ) );
                If ( nError > 0 ) Then
                Begin
                    Inc( p, nError );
                    nSize := nSize - nError;
                End
                Else
                    Raise EMSocket.Create( crsErrSendData );
            End;
        Finally
            FreeMem( buf );
        End;
    End;
End;

//   UDP Ϣ
//  յϢ
Function TMUDPSocket.RecvString : String;
Var
	nSize, nError, nFromLen : Integer;
    buf, p : PByte;
Begin
	Result := '';
	If ( FSocket <> INVALID_SOCKET ) Then
    Begin
        nFromLen := SizeOf( FRemote );
    	If ( Not WaitForRecv ) Then                      //  ȴݵ
        	Raise EMSocket.Create;
        nError := recvfrom( FSocket, nSize, SizeOf( nSize ), 0, FRemote, nFromLen );
        SocketError( nError );
        If ( nError <> SizeOf( nSize ) ) Then
            Raise EMSocket.Create( crsErrInvSize );
        GetMem( buf, nSize );                            //  仺
        Try
            FillMemory( buf, nSize, 0 );
            p := buf;
            While ( nSize > 0 ) Do
            Begin
                nError := cnMsgSize;
                If ( nSize < cnMsgSize ) Then
                    nError := nSize;
                If ( Not WaitForRecv ) Then              //  ȴݵ
                    Raise EMSocket.Create;
                nError := recvfrom( FSocket, p^, nError, 0, FRemote, nFromLen );
                SocketError( nError );
                If ( nError > 0 ) Then
                Begin
                    Inc( p, nError );
                    nSize := nSize - nError;
                End
                Else
                    Raise EMSocket.Create( crsErrRecvData );
            End;
            Result := PChar( buf );
        Finally
            FreeMem( buf );
        End;
    End;
End;

//  TMUDP Component

Constructor TMUDP.Create( AOwner : TComponent );
Begin
    Inherited Create( AOwner );
    If ( Not ( csDesigning In ComponentState ) ) Then
        FWindow := Forms.AllocateHWnd( SocketMessage );
    FServer     := Nil;
    FClient     := Nil;
    FRetStr     := '';
    FActive     := false;
    FRemoteHost := '';
    FRemotePort := 0;
    FLocalPort  := 0;
    FTimeOut    := 1000;  //  1 second
    FOnRequest  := Nil;
End;

Destructor TMUDP.Destroy;
Begin
    If ( Not ( csDesigning In componentState ) ) Then
    Begin
        StopServer;
        If ( FClient <> Nil ) Then
            FClient.Free;
        If ( FServer <> Nil ) Then
            FServer.Free;
        Forms.DeallocateHWnd( FWindow );
    End;
    Inherited Destroy;
End;

//   UDP 񣬿ʼ UDP 
Procedure TMUDP.StartServer;
Begin
    If ( Not FActive ) Then
    Begin
        FActive := true;
        If ( FServer = Nil ) Then
        Begin
            FServer := TMUDPSocket.Create;
	        FServer.LocalPort := FLocalPort;
        End;
        FServer.Open;
        //  Ϊ첽ʽյ Windows Ϣ
        SocketError( WSAAsyncSelect( FServer.Socket, FWindow, WM_MENTALUDP, FD_READ ) );
    End;
End;

//  ֹͣ UDP 񣬲ٽ UDP 
Procedure TMUDP.StopServer;
Begin
    If ( ( FActive ) AND ( FServer <> Nil ) ) Then
    Begin
        //  עϢ
        SocketError( WSAAsyncSelect( FServer.Socket, FWindow, 0, 0 ) );
        FServer.Close;
        FServer.Free;
        FServer := Nil;
        FActive := false;
    End;
End;

//  첽ʽϢ
Procedure TMUDP.SocketMessage( Var Message : TMessage );
Var
    s : String;
Begin
    If ( Message.Msg = WM_MENTALUDP ) Then
    Begin
        If ( WSAGetSelectEvent( Message.LParam ) = FD_READ ) Then
        Begin
            Try
                s := FServer.RecvString;
                If ( Assigned( FOnRequest ) ) Then
                    FOnRequest( Self, s );
            Except
                //  do nothing
            End;
        End;
    End
	Else
    	Message.Result := DefWindowProc( FWindow, Message.Msg, Message.WParam, Message.LParam );
End;

//  һUDPϢ
//  aMessage ΪҪ͵Ϣ
Procedure TMUDP.SendString( aMessage : String );
Begin
    Try
        If ( FClient = Nil ) Then
        Begin
            FClient := TMUDPSocket.Create;
            FClient.RemoteHost := FRemoteHost;
            FClient.RemotePort := FRemotePort;
        End;
        FClient.Open;
        FClient.SendString( aMessage );
    Finally
        FClient.Close;
        FClient.Free;
        FClient := Nil;
    End;
End;

//  һUDPҪȴӦ
//  aMessage ΪҪ͵Ϣ
//  ֵΪӦΪձʾڷӦ·'OK'
Function TMUDP.SendRequest( aMessage : String ) : String;
Var
    nTryTime : Integer;
Begin
    Try
        If ( FClient = Nil ) Then
        Begin
            FClient := TMUDPSocket.Create;
            FClient.RemoteHost := FRemoteHost;
            FClient.RemotePort := FRemotePort;
        End;
        nTryTime := cnRetryTimes;
        FClient.SetTimeOut( FTimeOut DIV nTryTime );
        FClient.Open;
        Repeat
            FClient.SendString( aMessage );
            Try
                FRetStr := FClient.RecvString;
            Except
                FRetStr := '';
            End;
            If ( ( FRetStr = '' ) AND ( WSAGetLastError <> WSAETIMEDOUT ) ) Then
                SocketError( SOCKET_ERROR );
            Dec( nTryTime );
        Until ( ( FRetStr <> '' ) OR ( nTryTime <= 0 ) );
        If ( nTryTime <= 0 ) Then
            SocketError( SOCKET_ERROR );
        Result := FRetStr;
    Finally
        FClient.Close;
        FClient.Free;
        FClient := Nil;
    End;
End;

Function TMUDP.GetActive : Boolean;
Begin
    Result := FActive;
End;

Procedure TMUDP.SetActive( aActive : Boolean );
Begin
    If ( aActive <> FActive ) Then
    Begin
        If ( Not ( csDesigning In ComponentState ) ) Then
        Begin
            StopServer;
            If ( aActive ) Then
                StartServer;
        End
        Else
            FActive := aActive;
    End;
End;

Procedure TMUDP.SetRemoteHost( aRemoteHost : String );
Begin
    If ( FClient <> Nil ) Then
        Raise EMSocket.Create( 'Can not change RemoteHost!' );
    FRemoteHost := aRemoteHost;
End;

Procedure TMUDP.SetRemotePort( aRemotePort : Integer );
Begin
    If ( FClient <> Nil ) Then
        Raise EMSocket.Create( 'Can not change RemotePort!' );
    FRemotePort := aRemotePort;
End;

Procedure TMUDP.SetLocalPort( aLocalPort : Integer );
Begin
    If ( ( aLocalPort <> FLocalPort )
    	AND ( Not ( csDesigning In ComponentState ) ) ) Then
    Begin
        StopServer;
        If ( FServer <> Nil ) Then
            Raise EMSocket.Create( 'Can not change LocalPort!' );
        FLocalPort := aLocalPort;
        If ( Active ) Then
            StartServer;
    End
    Else
        FLocalPort := aLocalPort;
End;

procedure TMUDP.Loaded;
begin
    Inherited;
    If ( FActive ) Then
        StartServer;
end;

{ EMSocket }

//   Socket Ϣ
constructor EMSocket.Create;
begin
    Inherited Create( crsErrSocketCode + IntToStr( WSAGetLastError ) );
end;

procedure Register;
begin
  RegisterComponents('MentalCtrls', [TMUDP]);
end;

Var
	wsad : TWSADATA;

initialization
	WSAStartup( $201, wsad );

finalization
	WSACleanUp;

end.

